// BonSrcDecoder.cpp: CBonSrcDecoder NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include <TypeInfo.h>
#include "BonSrcDecoder.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


typedef IBonDriver* (PFCREATEBONDRIVER)(void);


//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CBonSrcDecoder::CBonSrcDecoder(IEventHandler *pEventHandler)
	: CMediaDecoder(pEventHandler, 0UL, 1UL)
	, m_pBonDriver(NULL)
	, m_pBonDriver2(NULL)
	, m_hStreamRecvThread(NULL)
	, m_PauseEvent()
	, m_ResumeEvent()
	, m_bKillSignal(false)
	, m_TsStream(0x10000UL)
	, m_bIsPlaying(false)
	, m_BitRate(0)
	, m_StreamRemain(0)
	, m_bPurgeStreamOnChannelChange(true)
{
}

CBonSrcDecoder::~CBonSrcDecoder()
{
	CloseTuner();
}

void CBonSrcDecoder::Reset(void)
{
	if (m_pBonDriver == NULL)
		return;

	if (!PauseStreamRecieve()) {
		Trace(TEXT("Xg[MXbh܂B"));
		return;
	}

	// ̃Xg[j
	m_pBonDriver->PurgeTsStream();

	ResumeStreamRecieve();
}

const bool CBonSrcDecoder::InputMedia(CMediaData *pMediaData, const DWORD dwInputIndex)
{
	// \[XfR[_̂ߓ͂͏Ȃ
	return false;
}

const bool CBonSrcDecoder::OpenTuner(HMODULE hBonDrvDll)
{
	// I[v`FbN
	if (m_pBonDriver) {
		SetError(ERR_ALREADYOPEN,NULL);
		return false;
	}

	Trace(TEXT("`[iJĂ܂..."));

	// hCo|C^̎擾
	PFCREATEBONDRIVER *pf=(PFCREATEBONDRIVER*)::GetProcAddress(hBonDrvDll,"CreateBonDriver");
	if (pf == NULL) {
		SetError(ERR_DRIVER,TEXT("CreateBonDriver()̃AhX擾ł܂B"),
							TEXT("w肳ꂽDLLBonDriverł͂܂B"));
		return false;
	}
	if ((m_pBonDriver = pf()) == NULL) {
		SetError(ERR_DRIVER,TEXT("IBonDriver擾ł܂B"),
							TEXT("CreateBonDriver()̌ĂяoNULLԂ܂B"));
		return false;
	}

	HANDLE hThread = ::GetCurrentThread();
	int ThreadPriority = ::GetThreadPriority(hThread);

	// `[iJ
	if (!m_pBonDriver->OpenTuner()) {
		SetError(ERR_TUNEROPEN,TEXT("`[iJ܂B"),
							   TEXT("IBonDriver::OpenTuner()̌ĂяoŃG[Ԃ܂B"));
		goto OnError;
	}

	// BonDriver_HDUSAȂɃXbh̗DxHIGHESTɂ̂Ōɖ߂
	::SetThreadPriority(hThread, ThreadPriority);

	// IBonDriver2C^tF[X擾
	m_pBonDriver2 = dynamic_cast<IBonDriver2 *>(m_pBonDriver);

	/*
	// `lZbg
	if (m_pBonDriver2) {
		// IBonDriver2
		if (!m_pBonDriver2->SetChannel(0UL, 0UL)) {
			m_dwLastError = ERR_TUNER;
			goto OnError;
		}
	} else {
		// IBonDriver
		if (!m_pBonDriver->SetChannel(13U)) {
			m_dwLastError = ERR_TUNER;
			goto OnError;
		}
	}
	*/

	// Xg[MXbhN
	if (!m_PauseEvent.Create(true) || !m_ResumeEvent.Create()) {
		SetError(ERR_INTERNAL, TEXT("CxgIuWFNg쐬ł܂B"));
		goto OnError;
	}
	m_bKillSignal = false;
	m_bIsPlaying = false;
	m_hStreamRecvThread = ::CreateThread(NULL, 0UL, CBonSrcDecoder::StreamRecvThread, this, 0UL, NULL);
	if (!m_hStreamRecvThread) {
		SetError(ERR_INTERNAL, TEXT("Xg[MXbh쐬ł܂B"));
		goto OnError;
	}

	ClearError();

	Trace(TEXT("`[iJ܂B"));

	return true;

OnError:
	m_pBonDriver->CloseTuner();
	m_pBonDriver->Release();
	m_pBonDriver = NULL;
	m_pBonDriver2 = NULL;
	m_PauseEvent.Close();
	m_ResumeEvent.Close();
	return false;
}

const bool CBonSrcDecoder::CloseTuner(void)
{
	// Xg[~
	m_bIsPlaying = false;

	if (m_hStreamRecvThread) {
		// Xg[MXbh~
		Trace(TEXT("Xg[MXbh~Ă܂..."));
		m_bKillSignal = true;
		m_PauseEvent.Set();
		if (::WaitForSingleObject(m_hStreamRecvThread, 1000UL) != WAIT_OBJECT_0) {
			// XbhI
			::TerminateThread(m_hStreamRecvThread, 0UL);
			Trace(TEXT("Xg[MXbhI܂B"));
		}
		::CloseHandle(m_hStreamRecvThread);
		m_hStreamRecvThread = NULL;
	}
	m_PauseEvent.Close();
	m_ResumeEvent.Close();

	if (m_pBonDriver) {
		// `[i
		Trace(TEXT("`[iĂ܂..."));
		m_pBonDriver->CloseTuner();

		// hCoCX^XJ
		Trace(TEXT("hCoĂ܂..."));
		m_pBonDriver->Release();
		m_pBonDriver = NULL;
		m_pBonDriver2 = NULL;
		Trace(TEXT("`[i܂B"));
	}

	ClearError();

	return true;
}

const bool CBonSrcDecoder::IsOpen() const
{
	return m_pBonDriver != NULL;
}

const bool CBonSrcDecoder::Play(void)
{
	TRACE(TEXT("CBonSrcDecoder::Play()\n"));

	if (m_pBonDriver == NULL) {
		// `[iJĂȂ
		SetError(ERR_NOTOPEN,NULL);
		return false;
	}

	if (m_bIsPlaying) {
		// ɍĐ
		/*
		SetError(ERR_ALREADYPLAYING,NULL);
		return false;
		*/
		return true;
	}

	if (!PauseStreamRecieve()) {
		SetError(ERR_TIMEOUT,TEXT("Xg[MXbh܂B"));
		return false;
	}

	// ̃Xg[j
	m_pBonDriver->PurgeTsStream();

	// ʃfR[_Zbg
	ResetDownstreamDecoder();

	// Xg[ĐԂɂ
	m_bIsPlaying = true;

	ResumeStreamRecieve();

	ClearError();

	return true;
}

const bool CBonSrcDecoder::Stop(void)
{
	TRACE(TEXT("CBonSrcDecoder::Stop()\n"));

	if (!m_bIsPlaying) {
		// Xg[͍ĐłȂ
		/*
		SetError(ERR_NOTPLAYING,NULL);
		return false;
		*/
		return true;
	}

	if (!PauseStreamRecieve()) {
		SetError(ERR_TIMEOUT,TEXT("Xg[MXbh܂B"));
		return false;
	}

	m_bIsPlaying = false;

	ResumeStreamRecieve();

	ClearError();

	return true;
}

const bool CBonSrcDecoder::SetChannel(const BYTE byChannel)
{
	TRACE(TEXT("CBonSrcDecoder::SetChannel(%d)\n"), byChannel);

	if (m_pBonDriver == NULL) {
		// `[iJĂȂ
		SetError(ERR_NOTOPEN,NULL);
		return false;
	}

	if (!PauseStreamRecieve()) {
		SetError(ERR_TIMEOUT,TEXT("Xg[MXbh܂B"));
		return false;
	}

	// ̃Xg[j
	if (m_bPurgeStreamOnChannelChange)
		m_pBonDriver->PurgeTsStream();

	// `lύX
	if (!m_pBonDriver->SetChannel(byChannel)) {
		ResumeStreamRecieve();
		SetError(ERR_TUNER,TEXT("`l̕ύXł܂B"),
						   TEXT("IBonDriver::SetChannel()̌ĂяoŃG[Ԃ܂B"));
		return false;
	}

	// ʃfR[_Zbg
	ResetDownstreamDecoder();

	ResumeStreamRecieve();

	ClearError();

	return true;
}

const bool CBonSrcDecoder::SetChannel(const DWORD dwSpace, const DWORD dwChannel)
{
	TRACE(TEXT("CBonSrcDecoder::SetChannel(%lu, %lu)\n"), dwSpace, dwChannel);

	if (m_pBonDriver2 == NULL) {
		// `[iJĂȂ
		SetError(ERR_NOTOPEN,NULL);
		return false;
	}

	if (!PauseStreamRecieve()) {
		SetError(ERR_TIMEOUT,TEXT("Xg[MXbh܂B"));
		return false;
	}

	// ̃Xg[j
	if (m_bPurgeStreamOnChannelChange)
		m_pBonDriver2->PurgeTsStream();

	// `lύX
	if (!m_pBonDriver2->SetChannel(dwSpace, dwChannel)) {
		ResumeStreamRecieve();
		SetError(ERR_TUNER,TEXT("`l̕ύXł܂B"),
						   TEXT("IBonDriver2::SetChannel()̌ĂяoŃG[Ԃ܂B"));
		return false;
	}

	// ʃfR[_Zbg
	ResetDownstreamDecoder();

	ResumeStreamRecieve();

	ClearError();

	return true;
}

const float CBonSrcDecoder::GetSignalLevel(void)
{
	if (m_pBonDriver == NULL) {
		// `[iJĂȂ
		SetError(ERR_NOTOPEN,NULL);
		return 0.0f;
	}

	ClearError();

	// MxԂ
	return m_pBonDriver->GetSignalLevel();
}

const bool CBonSrcDecoder::IsBonDriver2(void) const
{
	// IBonDriver2C^tF[X̎gpۂԂ
	return m_pBonDriver2 != NULL;
}

LPCTSTR CBonSrcDecoder::GetSpaceName(const DWORD dwSpace) const
{
	// `[jOԖԂ
	if (m_pBonDriver2 == NULL) {
		//m_dwLastError = ERR_NOTOPEN;
		return NULL;
	}
	return m_pBonDriver2->EnumTuningSpace(dwSpace);
}

LPCTSTR CBonSrcDecoder::GetChannelName(const DWORD dwSpace, const DWORD dwChannel) const
{
	// `lԂ
	if (m_pBonDriver2 == NULL) {
		//m_dwLastError = ERR_NOTOPEN;
		return NULL;
	}
	return m_pBonDriver2->EnumChannelName(dwSpace, dwChannel);
}

const bool CBonSrcDecoder::PurgeStream(void)
{
	TRACE(TEXT("CBonSrcDecoder::PurgeStream()\n"));

	if (m_pBonDriver == NULL) {
		// `[iJĂȂ
		SetError(ERR_NOTOPEN,NULL);
		return false;
	}

	if (!PauseStreamRecieve()) {
		SetError(ERR_TIMEOUT,TEXT("Xg[MXbh܂B"));
		return false;
	}

	// ̃Xg[j
	m_pBonDriver->PurgeTsStream();

	ResumeStreamRecieve();

	ClearError();

	return true;
}


void CBonSrcDecoder::OnTsStream(BYTE *pStreamData, DWORD dwStreamSize)
{
	if (m_bIsPlaying) {
		// ŏʃfR[_ɓ͂
		m_TsStream.SetData(pStreamData, dwStreamSize);
		OutputMedia(&m_TsStream);
	}
}


DWORD WINAPI CBonSrcDecoder::StreamRecvThread(LPVOID pParam)
{
	CBonSrcDecoder *pThis = static_cast<CBonSrcDecoder *>(pParam);

	::CoInitialize(NULL);

	// `[iTSf[^oXbh
	while (true) {
		DWORD BitRateTime=::GetTickCount();
		DWORD TotalSize=0;
		pThis->m_BitRate=0;

		while (!pThis->m_PauseEvent.IsSignaled()) {
			// ȗ̂߃|[O̗p
			DWORD dwStreamRemain = 0UL;

			do {
				BYTE *pStreamData = NULL;
				DWORD dwStreamSize = 0UL;

				if (pThis->m_pBonDriver->GetTsStream(&pStreamData,&dwStreamSize,&dwStreamRemain)
						&& pStreamData && dwStreamSize) {
#if 1
					pThis->OnTsStream(pStreamData, dwStreamSize);
#else
					// xɑTCYCPUgp̕ϓȂȂ
					DWORD Remain,Size;

					for (Remain=dwStreamSize;Remain>0;Remain-=Size) {
						Size=min(Remain,188*64);
						pThis->OnTsStream(pStreamData+(dwStreamSize-Remain),Size);
					}
#endif
					TotalSize+=dwStreamSize;
				}

				// rbg[gvZ
				DWORD Now=::GetTickCount();
				if (Now>=BitRateTime) {
					if (Now-BitRateTime>=1000) {
						pThis->m_BitRate=(DWORD)(((ULONGLONG)TotalSize*8*1000)/(ULONGLONG)(Now-BitRateTime));
						BitRateTime=Now;
						TotalSize=0;
					}
				} else {
					BitRateTime=Now;
					TotalSize=0;
				}
				pThis->m_StreamRemain=dwStreamRemain;
				if (pThis->m_PauseEvent.IsSignaled())
					goto Break;
			} while (dwStreamRemain>0);

			// EFCg(24MbpsƂĎ̃f[^܂Ŗ15ms)
			::Sleep(5UL);
			//pThis->m_pBonDriver->WaitTsStream(20);
		}
	Break:
		if (pThis->m_bKillSignal)
			break;
		pThis->m_PauseEvent.Reset();
		pThis->m_ResumeEvent.Set();
		pThis->m_PauseEvent.Wait(5000);
		pThis->m_PauseEvent.Reset();
		//pThis->m_ResumeEvent.Set();
	}

	pThis->m_BitRate=0;

	::CoUninitialize();

	TRACE(TEXT("CBonSrcDecoder::StreamRecvThread() return\n"));

	return 0UL;
}


/*
	Xg[̎Mꎞ~
	PurgeXg[ǂ݂ɍsė邱Ƃ̂ŁȂ΍
*/
bool CBonSrcDecoder::PauseStreamRecieve(DWORD TimeOut)
{
	m_ResumeEvent.Reset();
	m_PauseEvent.Set();
	if (m_ResumeEvent.Wait(TimeOut) == WAIT_TIMEOUT) {
		m_PauseEvent.Reset();
		return false;
	}
	return true;
}


bool CBonSrcDecoder::ResumeStreamRecieve(DWORD TimeOut)
{
	m_PauseEvent.Set();
	/*
	if (m_ResumeEvent.Wait(TimeOut) == WAIT_TIMEOUT)
		return false;
	*/
	return true;
}


int CBonSrcDecoder::NumSpaces() const
{
	int i;

	for (i = 0; GetSpaceName(i) != NULL; i++);
	return i;
}


LPCTSTR CBonSrcDecoder::GetTunerName() const
{
	if (m_pBonDriver2 == NULL) {
		//m_dwLastError = ERR_NOTOPEN;
		return NULL;
	}
	return m_pBonDriver2->GetTunerName();
}


int CBonSrcDecoder::GetCurSpace() const
{
	if (m_pBonDriver2 == NULL) {
		//m_dwLastError = ERR_NOTOPEN;
		return -1;
	}
	return m_pBonDriver2->GetCurSpace();
}


int CBonSrcDecoder::GetCurChannel() const
{
	if (m_pBonDriver2 == NULL) {
		//m_dwLastError = ERR_NOTOPEN;
		return -1;
	}
	return m_pBonDriver2->GetCurChannel();
}


DWORD CBonSrcDecoder::GetBitRate() const
{
	return m_BitRate;
}


DWORD CBonSrcDecoder::GetStreamRemain() const
{
	return m_StreamRemain;
}


void CBonSrcDecoder::SetPurgeStreamOnChannelChange(bool bPurge)
{
	TRACE(TEXT("CBonSrcDecoder::SetPurgeStreamOnChannelChange(%s)\n"), bPurge ? TEXT("true") : TEXT("false"));
	m_bPurgeStreamOnChannelChange = bPurge;
}
