// BonSrcDecoder.h: CBonSrcDecoder NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#pragma once


#include "MediaDecoder.h"
#include "IBonDriver.h"
#include "IBonDriver2.h"


/////////////////////////////////////////////////////////////////////////////
// Bon\[XfR[_(`[iTSXg[M)
/////////////////////////////////////////////////////////////////////////////
// Output	#0	: CMediaData		TSXg[
/////////////////////////////////////////////////////////////////////////////

class CBonSrcDecoder : public CMediaDecoder
{
public:
	// G[R[h
	enum {
		ERR_NOERROR,		// G[Ȃ
		ERR_DRIVER,			// hCoG[
		ERR_TUNEROPEN,		// `[iI[vG[
		ERR_TUNER,			// `[iG[
		ERR_NOTOPEN,		// `[iJĂȂ
		ERR_ALREADYOPEN,	// `[iɊJĂ
		ERR_NOTPLAYING,		// ĐĂȂ
		ERR_ALREADYPLAYING,	// ɍĐĂ
		ERR_TIMEOUT,		// ^CAEg
		ERR_INTERNAL		// G[
	};

	CBonSrcDecoder(IEventHandler *pEventHandler = NULL);
	virtual ~CBonSrcDecoder();

// IMediaDecoder
	virtual void Reset(void);
	virtual const bool InputMedia(CMediaData *pMediaData, const DWORD dwInputIndex = 0UL);

// CBonSrcDecoder
	const bool OpenTuner(HMODULE hBonDrvDll);
	const bool CloseTuner(void);
	const bool IsOpen() const;

	const bool Play(void);
	const bool Stop(void);

	const bool SetChannel(const BYTE byChannel);
	const bool SetChannel(const DWORD dwSpace, const DWORD dwChannel);
	const float GetSignalLevel(void);

	const bool IsBonDriver2(void) const;
	LPCTSTR GetSpaceName(const DWORD dwSpace) const;
	LPCTSTR GetChannelName(const DWORD dwSpace, const DWORD dwChannel) const;

	const bool PurgeStream(void);

	// Append by HDUSTest̒̐l
	int NumSpaces() const;
	LPCTSTR GetTunerName() const;
	int GetCurSpace() const;
	int GetCurChannel() const;
	DWORD GetBitRate() const;
	DWORD GetStreamRemain() const;
	void SetPurgeStreamOnChannelChange(bool bPurge);

private:
	static DWORD WINAPI StreamRecvThread(LPVOID pParam);
	void OnTsStream(BYTE *pStreamData, DWORD dwStreamSize);
	bool PauseStreamRecieve(DWORD TimeOut = 3000);
	bool ResumeStreamRecieve(DWORD TimeOut = 3000);

	IBonDriver *m_pBonDriver;
	IBonDriver2 *m_pBonDriver2;	

	HANDLE m_hStreamRecvThread;
	CLocalEvent m_PauseEvent;
	CLocalEvent m_ResumeEvent;
	volatile bool m_bKillSignal;

	CMediaData m_TsStream;

	bool m_bIsPlaying;
	DWORD m_dwLastError;

	DWORD m_BitRate;
	DWORD m_StreamRemain;

	bool m_bPurgeStreamOnChannelChange;
};
