// AacDecoder.cpp: CAacDecoder NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "AacDecoder.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


// "Code from FAAD2 is copyright (c) Nero AG, www.nero.com"
#pragma comment(lib, "LibFaad.lib")


//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CAacDecoder::CAacDecoder(IPcmHandler *pPcmHandler)
	: m_pPcmHandler(pPcmHandler)
	, m_hDecoder(NULL)
	, m_bInitRequest(false)
	, m_byLastChannelConfig(0U)
{
}


CAacDecoder::~CAacDecoder()
{
	CloseDecoder();
}


const bool CAacDecoder::OpenDecoder(void)
{
	CloseDecoder();

	// FAAD2I[v
	m_hDecoder = ::NeAACDecOpen();
	if (m_hDecoder==NULL)
		return false;

	// ftHgݒ擾
	NeAACDecConfigurationPtr pDecodeConfig = ::NeAACDecGetCurrentConfiguration(m_hDecoder);

	/*
	// OpenNULLɂ͂ȂȂ
	if (pDecodeConfig==NULL) {
		CloseDecoder();
		return false;
	}
	*/

	// fR[_ݒ
	pDecodeConfig->defObjectType = LC;
	pDecodeConfig->defSampleRate = 48000UL;
	pDecodeConfig->outputFormat = FAAD_FMT_16BIT;
	pDecodeConfig->downMatrix = 0;
	pDecodeConfig->useOldADTSFormat = 0;

	if (!::NeAACDecSetConfiguration(m_hDecoder, pDecodeConfig)) {
		CloseDecoder();
		return false;
	}

	m_bInitRequest = true;
	m_byLastChannelConfig = 0xFFU;

	return true;
}


void CAacDecoder::CloseDecoder()
{
	// FAAD2N[Y
	if (m_hDecoder) {
		::NeAACDecClose(m_hDecoder);
		m_hDecoder = NULL;
	}
}


const bool CAacDecoder::ResetDecoder(void)
{
	if (m_hDecoder == NULL)
		return false;

	return OpenDecoder();
}


const bool CAacDecoder::Decode(const CAdtsFrame *pFrame)
{
	if (m_hDecoder == NULL) {
		/*
		if (!OpenDecoder())
			return false;
		*/
		return false;
	}

	// fR[h

	// t[
	if (m_bInitRequest) {
		unsigned long SampleRate;
		unsigned char Channels;

		if (::NeAACDecInit(m_hDecoder, const_cast<BYTE*>(pFrame->GetData()), pFrame->GetSize(), &SampleRate, &Channels) < 0) {
			return false;
		}
		m_bInitRequest = false;
		m_byLastChannelConfig = pFrame->GetChannelConfig();
	} else if (pFrame->GetChannelConfig() != m_byLastChannelConfig) {
		// `lݒ肪ωAfR[_Zbg
		ResetDecoder();
		m_byLastChannelConfig = pFrame->GetChannelConfig();
	}

	// fR[h
	NeAACDecFrameInfo FrameInfo;
	//::ZeroMemory(&FrameInfo, sizeof(FrameInfo));

	BYTE *pPcmBuffer = (BYTE *)::NeAACDecDecode(m_hDecoder, &FrameInfo, const_cast<BYTE*>(pFrame->GetData()), pFrame->GetSize());

	if (FrameInfo.error==0) {
		if (FrameInfo.samples>0) {
			// L-PCMnhɒʒm
			if (m_pPcmHandler)
				m_pPcmHandler->OnPcmFrame(this, pPcmBuffer, FrameInfo.samples / FrameInfo.channels, FrameInfo.channels);
		}
	} else {
		// G[
#ifdef _DEBUG
		::OutputDebugString(TEXT("CAacDecoder::Decode error - "));
		::OutputDebugStringA(NeAACDecGetErrorMessage(FrameInfo.error));
		::OutputDebugString(TEXT("\n"));
#endif
#if 0
		// ƃ[N
		m_bInitRequest = true;
#else
		// ZbgĂ݂
		// {t[̃fR[hŃG[NxɈXZbgKv͂Ȃ͂c
		ResetDecoder();
#endif
	}

	return true;
}


void CAacDecoder::OnAdtsFrame(const CAdtsParser *pAdtsParser, const CAdtsFrame *pFrame)
{
	// CAdtsParser::IFrameHandler̎
	Decode(pFrame);
}
